// Language filter
var gsPersistedLang = "(all)";
// The SELECT object
var selObj = null;
window.onbeforeunload=Window_BeforeUnload;

function InitDevLangFilter()
{
  var supported = false;
  var currLang;
  
	try
	{
		gsPersistedLang = Load("gsPersistedLang");
		currLang = gsPersistedLang;
	}
	// Using frames does not seem to capture page information online, get from cookie
	catch(e)
	{
		currLang = GetCookie("lang");
	}

  selObj = document.getElementById("selectLanguage");
  if (selObj != null)
  {
		for (i = 0; i < selObj.options.length; i++)
		{
			if (selObj.options(i).value == currLang)
			{
        supported = true;
        break;
      }
    }
	}
	
  if (supported == false)
    currLang = "(all)";

  if (selObj != null)
  {
    for (i = 0; i < selObj.options.length; i++)
    {
      if (selObj.options(i).value == currLang)
      {
        selObj.options(i).selected = true;
        break;
      }
    }
  }
  ChangeLanguage2(currLang);
}

/* Fired when user changes language in select */
function ChangeLanguage()
{
	selObj = document.getElementById("selectLanguage");
	if(selObj != null){
  	gsPersistedLang = selObj.options[selObj.selectedIndex].value;
		try
		{
			// Save to userData
 			Save("gsPersistedLang", gsPersistedLang);
 		}catch(e)
 		{
	 		// Do nothing
 		}
 		// Redraw objects based on the language chosen by user
  	ChangeLanguage2(gsPersistedLang);
	}
}

/* Redraw objects based on the language chosen by user */
function ChangeLanguage2(lang)
{
  var oRows = document.getElementsByTagName("TR");
  for(var j = 0; j < oRows.length; ++j)
  {
    var oRow = oRows[j];
    if(oRow.id.indexOf("_syntax") != -1)
    { 
			if(oRow.id == lang + "_syntax" || lang == "(all)")
      	oRow.style.display = "block";
			else
      	oRow.style.display = "none";
    }
  }
  
  var oSpans = document.getElementsByTagName("SPAN");
  for (var j = 0; j < oSpans.length; ++j)
  {
    var oSpan = oSpans[j];
    var dLang = oSpan.getAttribute("DEVLANG");
    if (dLang != null)
    {
      // Span tag can now contain multiple devlang values separated by a
      // semicolon (ie: <span devlang="cs;xaml">). This update checks to see if
      // the current language matches any of languages specified in the devlang
      // attribute.
      var aLang = dLang.split(';');
      
      for(var i = 0; i < aLang.length; i++)
      {
        if (aLang[i] == lang || lang == "(all)")
        {
          oSpan.style.display = "block";
          break;
        }
        else
          oSpan.style.display = "none";
      }
    }
  }
}
/* Saves the user settings before unloading page */
function Window_BeforeUnload()
{
	try
	{
		gsPersistedLang = selObj.options[selObj.selectedIndex].value
		Save("gsPersistedLang", gsPersistedLang);
	}
	catch(e)
	{

		var expiration = new Date(3000, 1, 1);
    DeleteCookie("lang");
    SetCookie("lang", gsPersistedLang, expiration, "/");
    
  }
 	
}

/* Begin Language Filter userData store */
function Load(key)
{
	userDataCache.load("docSettings");
	var value = userDataCache.getAttribute(key);
	return value;
}

function Save(key, valueString)
{
	userDataCache.setAttribute(key, valueString);
	userDataCache.save("docSettings");
}
/* End Language Filter userData store */


/* Begin Cookie information */
function SetCookie(name, value, expires, path, domain, secure) 
{
  document.cookie = name + "=" + escape(value) + 
    ((expires == null) ? "" : "; expires=" + expires.toGMTString()) +
    ((path == null)    ? "" : "; path=" + escape(path)) +
    ((domain == null)  ? "" : "; domain=" + escape(domain)) +
    ((secure == null)  ? "" : "; secure");
}

function GetCookie(name)
{ 
  var cname = name + "=";               
  var dc = document.cookie;             
  
  if (dc.length > 0) 
  {
    begin = dc.indexOf(cname);       
    if (begin != -1) 
    {
      begin += cname.length;       
      end = dc.indexOf(";", begin);
      if (end == -1) end = dc.length;
      return unescape(dc.substring(begin, end));
    } 
  }
  return null;
}

function DeleteCookie (name, path, domain) 
{
  if (GetCookie(name)) 
  {
    var expires = new Date(1970, 1, 1);
    document.cookie = name + "=" + ((path == null) ? "" : "; path=" + path) + ((domain == null) ? "" : "; domain=" + domain) + "; expires=" + expires.toGMTString();
  }
}
/* End Cookie information */
